/*
Scrivere un programma per la gestione delle servizi ERSU per gli studenti universitari. Ogni  studente  caratterizzato dalle seguenti informazioni: codice fiscale, matricola, tipo di servizio (Abitativi=0, Ristorazione=1, Borse di Studio=2),  reddito ISEEU.
Gli studenti sono organizzati in memoria come un vettore con 60 elementi.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Lettura da file e copia nel vettore degli studenti  con un certo tipo di servizio;
2) Inserimento di una nuovo studente;
3) Ordinamento degli studenti rispetto al reddito ISEEU;
4) Visualizzazione degli studenti con un reddito inferiore a un certo valore;
5) Salvataggio su file degli studenti.


*/


#include<stdio.h>

struct ersu {
       char codice [17];
       long matricola;
       int tipo;
       float reddito;
       };
       
void leggi(struct ersu *pe)
{     
      
      printf("\n inserisci codice fiscale : \a\n");
      scanf("%s",pe->codice);
      printf("\n inserisci matricola : \a\n");
      scanf("%ld",&pe->matricola);
      printf("\n inserisci tipo di servizio :  \n 0 = ABITATIVI \n 1 = RISTORAZIONE \n 2 = BORSE DI STUDIO \a\n");
      scanf("%d",&pe->tipo);
      printf("\n inserisci reddito ISEEU : \a\n");
      scanf("%f",&pe->reddito);
}      
             
 void inserimento (struct ersu *V, int *pn)
 {
      struct ersu e;
          
   if(*pn<60)
      { leggi(&e); 
        V[*pn]=e;
        (*pn)++;
      }
      else printf("\n vettore pieno \n");
 }

 void ordina (struct ersu *V, int n)
 {
      int sup;
      int i;
      struct ersu temp;
      
      for(sup=n-1;sup>0;sup--)
       for (i=0;i<sup;i++)
         if(V[i].reddito>V[i+1].reddito)
           {
             temp=V[i];
             V[i]=V[i+1];
             V[i+1]=temp;
           } 
 }
 
 void visualizza (struct ersu *V, int n)
 {
      int i;
      float reddito;
      
      printf("\n visualizza studenti con un reddito inferiore di :  ");
      scanf("%f",&reddito);
      
      for(i=0;i<n;i++)
           if(V[i].reddito<reddito)
            {
               printf("\n codice fiscale : %s",V[i].codice);
               printf("\n matricola : %ld",V[i].matricola);
               printf("\n tipo di servizio : %d",V[i].tipo);
               printf("\n reddito: %f\n",V[i].reddito);
            }
 }
 
 void letturadafile (struct ersu *V, int *pn)
 {
      int i=0;
      int tipo;
      FILE *pf;
      struct ersu d;
      
      printf("\n inserisci tipo di servizio:  ");
      scanf("%d",&tipo);
      
      pf=fopen("ersu.org","rb");
      if(pf)
      {
           while(i<60 && fread(&d,sizeof(struct ersu),1,pf)>0)
             
             if(d.tipo==tipo)
              {
                V[i]=d;
                i++;
              }
           fclose(pf);
      }
      else printf(" \n errore in lettura \n ");
      *pn=i;
 }                                      

 void salva (struct ersu *V, int n)
 {
      int i=0;
      FILE *pf;
      
      pf=fopen("ersu.org","wb");
      if(pf)
      {
            for (i=0;i<n;i++)
               fwrite(&V[i],sizeof(struct ersu),1,pf);
            fclose(pf);
      }
      else printf("\n errore \n");
 }
 
 
 main() {
        struct ersu VE[60];
        int n=0;
        int scelta;
        
        do {
             printf("\n\n SCEGLI TRA LE SEGUENTI OPZIONI \n");
             printf("\n 1 INSERIMENTO \n 2 VISUALIZZAZIONE \n 3 ORDINAMENTO \n 4 SALVA \n 5 LETTURA \n 0 ESCI \n \n \n");
             scanf("%d",&scelta);
             
             switch (scelta){
                               
                               case 1 : inserimento (VE,&n);
                               break;
                               
                               case 2 : visualizza (VE,n);
                               break;
                               
                               case 3 : ordina (VE,n);
                               break;
                               
                               case 4 : salva (VE,n);
                               break;
                               
                               case 5 : letturadafile (VE,&n);
                               break;
                               
                               default:;
                               
                               }
             } while (scelta!=0);
 }
