/*
Scrivere un programma per la gestione delle tessere mensa degli studenti universitari. Ogni  tessera  caratterizzata dalle seguenti informazioni: nominativo, matricola, facolt (Economia=0, Lettere=1, Ingegneria=2, Scienze=3),  fascia di reddito (1..3).
Le tessere sono organizzate in memoria come un vettore con 60 elementi.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Lettura da file e copia nel vettore delle tessere relative a una fascia di reddito;
2) Inserimento di una nuova tessera;
3) Cambio della fascia di reddito di uno studente (chiedere matricola e facolt);
4) Visualizzazione delle tessere relative a una certa fascia di reddito;
5) Salvataggio su file delle tessere.

*/

#include <stdio.h>
#include <stdlib.h> 

struct tessera
{
       char nominativo[20];
       long matricola;
       int facolta;
       int fascia;
};

void inserimento(struct tessera *V,int *pn)
{
     struct tessera t;

       if(*pn<60)
        {
          printf("Nominativo: ");
          scanf("%s",t.nominativo);
          printf("Matricola: ");
          scanf("%ld",&t.matricola);
          printf("Facolta: 0)Economia 1)Lettere 2)Ingegneria 3)Scienze");
          scanf("%d",&t.facolta);
          printf("Fascia reddito: (1..3)");
          scanf("%d",&t.fascia);
          
          V[*pn]=t;
          (*pn)++;
         }
       else
          printf("vettore pieno");
}

void cambia(struct tessera *V,int n)
{
     int i;
     long matricola;
     int facolta;
     int fascia;
     
     printf("Matricola: ");
     scanf("%ld",&matricola);
     printf("Facolta': 0)Economia 1)Lettere 2)Ingegneria 3)Scienze");
     scanf("%d",&facolta);
     
     for(i=0;i<n;i++)
       if(V[i].matricola==matricola && V[i].facolta==facolta)
          break;
     
     if(i<n)  /*trovato */    
       {
          printf("Inserisci la nuova fascia di reddito: (1..3): ");
          scanf("%d",&fascia);
          V[i].fascia=fascia;
       }
     else 
          printf("Nessun elemento trovato\n\n");
}

void visualizza (struct tessera *V,int n)
{
     int i;
     int fascia;
     
     printf("inserisci fascia: (1..3)");
     scanf("%d",&fascia);

     for(i=0;i<n;i++)
      if(V[i].fascia==fascia)
      {
        printf("Nominativo: %s\n",V[i].nominativo);
        printf("Matricola: %ld\n",V[i].matricola);
        printf("Facolta': %d\n\n",V[i].facolta);     
      }
}

void salva(struct tessera *V,int n)
{
     int i;
     FILE *pf;
     
     pf=fopen("tessere.dat","wb");
     if(pf)
     {
        for(i=0;i<n;i++)
          fwrite(&V[i],sizeof(struct tessera),1,pf);
        fclose(pf);
     }
     else 
       printf("errore in scrittura\n\n");
}

void lettura(struct tessera *V,int *pn)   
{
     int i;
     FILE *pf;
     int fascia;
     struct tessera t;
     
     printf("inserisci la fascia: (1..3)");
     scanf("%d",&fascia);
     
     i=0;
     pf=fopen("tessere.dat","rb");
     if(pf)
     {
       while(i<60 && fread(&t,sizeof(struct tessera),1,pf)>0)
          if(t.fascia==fascia)
             {
               V[i]=t;
               i++;
             }
                 
       fclose(pf);   
     }
     else    printf("errore in lettura");
     
     (*pn)=i;
}  
     
int main()
{
    int n,scelta;     
    struct tessera T[60];
    
    n=0;
    do
    {
      printf("\nscegli tra: \n");
      printf("1)inserimento\n2)visualizza\n3)cambia\n4)salva\n5)leggi\n0)fine\n\n");
      scanf("%d",&scelta);
      
         switch(scelta)
         {    
            case 1: lettura(T,&n);
                    break;
                    
            case 2: inserimento(T,&n);
                    break;
                   
           case 3:  cambia(T,n); 
                    break;
                   
           case 4:  visualizza(T,n);
                    break;
                    
           case 5:  salva(T,n);
                    break;
                    
          
           
           default: ;
          }
     }
     while(scelta!=0);


}
    
                                      
    
