/*Scrivere un programma per la gestione delle tessere mensa degli lavoratori di un'azienda. Ogni  tessera  caratterizzata dalle seguenti informazioni: nominativo, matricola, numero reparto, classe stipendiale (1..5).
Le tessere sono organizzate in memoria come un vettore con 50 elementi.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1) Inserimento di una nuova tessera;
2) Eliminazione di una tessera (chiedere la matricola);
3) Visualizzazione delle tessere relative a una certo reparto;
4) Salvataggio su file delle tessere.

All'avvio del programma i valori precedentemente salvate su file devono essere letti e copiati nel vettore mediante una funzione di inizializzazione del vettore
*/

#include <stdio.h>

struct mensa {
       char nominativo[50];
       long matricola;
       int reparto;
       int classe;
           };
           
void inserimento(struct mensa *M,int *pn)
{ 
  struct mensa m;
  
  if(*pn<50)
  { printf("Cognome_Nome: ");
    scanf("%s",m.nominativo);
    printf("Matricola: ");
    scanf("%ld",&m.matricola);
    printf("Numero reparto: ");
    scanf("%d",&m.reparto);
    printf("Classe stipendiale (1..5): ");
    scanf("%d",&m.classe);
    M[*pn]=m;
    (*pn)++;
   }
   else printf("Vettore pieno\n");
}

void elimina(struct mensa *M,int *pn)
{ int p,i;
  long matricola;
  
  printf("Matricola: ");
  scanf("%ld",&matricola);
  
  for(p=0;p<*pn;p++)
    if(M[p].matricola==matricola)
        break;
  if(p<*pn)
  { 
    for(i=p;i<*pn-1;i++)
       M[i]=M[i+1];
    (*pn)--;
  }
  else printf("Elemento non trovato\n");
}

void visualizza(struct mensa *M,int n)
{ int i;
  int reparto;
  
  printf("Numero reparto: ");
  scanf("%d",&reparto);
  
  for(i=0;i<n;i++)
   if(M[i].reparto==reparto)
     { printf("Cognome_Nome: %s\n",M[i].nominativo);
       printf("Matricola: %d\n",M[i].matricola);
       printf("Classe stipendiale: %d\n",M[i].classe);
     }
   
}

void salva(struct mensa *M,int n)
{ int i;
  FILE *pf;
  pf=fopen("tessere.tex","wb");
  if(pf)
  { for(i=0;i<n;i++)
       fwrite(&M[i],sizeof(struct mensa),1,pf);
    fclose(pf);
  }
  else printf("Errore in scrittura\n");
}

void inizializza(struct mensa *M,int *pn)
{ int i;
  struct mensa m;
  FILE *pf;
  
  i=0;
  pf=fopen("tessere.tex","rb");
  if(pf)
  { while(i<50 && fread(&m,sizeof(struct mensa),1,pf)>0)
    { M[i]=m;
      i++;
    }
    fclose(pf);
   }
   else printf("Errore in lettura\n");
   
   *pn=i;
}

main()
{ struct mensa V[50];
  int n;
  int scelta;
  inizializza(V,&n);
  do { printf("Scegli:\n1)Inserimento\n2)Eliminazione\n3)Visualizzazione\n4)Salvataggio\n0)Fine\n");
       scanf("%d",&scelta);
       switch(scelta) {
                      case 1: inserimento(V,&n);
                              break;
                      case 2: elimina(V,&n);
                              break;
                      case 3: visualizza(V,n);
                              break;
                      case 4: salva(V,n);
                              break;
                      default:;
                      }
       }
       while(scelta!=0);
}

    
       
